package edu.cmu.qatar._15121.hw7;

public class MusicLibrary {

	/**
	 * 
	 * Add a song to the music library. Throws the SongAlreadyExistsException if the
	 * song to be added already exists in the library.
	 * 
	 * This method has no specific efficiency requirements.
	 * 
	 * @param artist    The artist of the song
	 * @param title     The title of the song
	 * @param album     The album the song is a part of
	 * @param genre     The genre of the song
	 * @param playlists The array of playlists this song is on. null if the song is
	 *                  not on any playlists.
	 * @throws SongAlreadyExistsException when the song already exists in the
	 *                                    library.
	 */
	public void addSong(String artist, String title, String album, String genre, String[] playlists)
			throws SongAlreadyExistsException {
		return;
	}

	/**
	 * Return all of the songs in the library
	 * 
	 * This must be O(N), where N is the number of songs in the library.
	 * 
	 * @return Array of songs
	 */
	public Song[] getAllSongs() {
		return null;
	}
	
	/**
	 * Input the music database from the file specified by filename. If the file
	 * does not exist, then add nothing to the library.
	 * 
	 * This method has no specific efficiency requirements, but in order to
	 * confidently pass Autolab you should be able to load 250,000 songs in less
	 * than 15 seconds.
	 * 
	 * @param filename The file to load the music from
	 */
	public void loadMusicDb(String filename) {
		return;
	}

	/**
	 * Return all of the artists in the library without duplicates
	 * 
	 * This must be O(M), where M is the number of artists.
	 * 
	 * @return Array of artist names
	 */
	public String[] getAllArtists() {
		return null;
	}

	/**
	 * Retrieve all of the songs by a given artist and return them
	 * 
	 * This must be O(M), where M is the number of songs by that artist.
	 * 
	 * @param artist The artist to search for
	 * @return An array of songs by the given artist. If the artist is not in the
	 *         MusicLibrary, return an empty array.
	 */
	public Song[] getSongsByArtist(String artist) {
		return null;
	}

	/**
	 * Retrieve all of the genres in the library without duplicates
	 * 
	 * This must be O(M), where M is the number of genres.
	 * 
	 * @return An array of strings, with each string being a genre
	 */
	public String[] getGenres() {
		return null;
	}

	/**
	 * Retrieve all of the songs with a given genre and return them
	 * 
	 * This must be O(M), where M is the songs within the specified genre.
	 * 
	 * @param genre The genre
	 * @return An array of songs by with the given genre. If there are no songs with
	 *         that genre, return an empty array.
	 */
	public Song[] getSongsByGenre(String genre) {
		return null;
	}

	/**
	 * Create a new playlist with the specified name, adding it to the list of
	 * playlists. If a playlist with that name already exists, do not create another
	 * one.
	 * 
	 * This method has no specific efficiency requirements, but be reasonable.
	 * 
	 * @param playlistName The name of the playlist to create
	 */
	public void createPlaylist(String playlistName) {
		return;
	}

	/**
	 * 
	 * Add all songs with the specified title to the specified playlist. If the
	 * playlist does not already exist, throw the appropriate exception.
	 * 
	 * @param title        Title of song to add to the playlist
	 * @param playlistName The name of the playlist to add the some to
	 * @throws PlaylistNotFoundException when the playlist specified does not exist
	 */
	public void addSongToPlaylist(String title, String playlistName) 
			throws PlaylistNotFoundException {
		return;
	}

	/**
	 * Return all of the playlists in the library without duplicates
	 * 
	 * This must be O(M), where M is the number of playlists.
	 * 
	 * @return Array of playlist names
	 */
	public String[] getPlaylists() {
		return null;
	}

	/**
	 * 
	 * Return an array of all the songs in a playlist. If the playlist does not
	 * exist, throw the appropriate exception.
	 * 
	 * This must be O(M), where M is the number of songs in the playlist.
	 * 
	 * @param playlist The name of the playlist
	 * @return An array of songs in the given playlist. If there are no songs in the
	 *         playlist, return an empty array.
	 * @throws PlaylistNotFoundException when the playlist does not exist
	 */
	public Song[] getSongsByPlaylist(String playlist) throws PlaylistNotFoundException {
		return null;
	}

	/**
	 * Write the music database to the file specified by filename. The music DB must
	 * be output using the same format as the input. (So, you must be able to input
	 * a file that you output.)
	 * 
	 * @param filename The file to write the music to
	 */
	public void writeMusicDb(String filename) {
		return;
	}
}
